"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _EmptyKey = _interopRequireDefault(require("../../constants/EmptyKey"));

var _isUndefined = _interopRequireDefault(require("../../utils/isUndefined"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function adaptOptionsForSingularResource(_ref, args) {
  var paramsOptional = _ref.paramsOptional,
      acceptsValues = _ref.acceptsValues;
  var definedArgs = getNumberOfArguments(args);

  if (acceptsValues) {
    if (paramsOptional) {
      switch (definedArgs) {
        case 1:
          return {
            params: _EmptyKey["default"],
            values: args[0],
            actionCreatorOptions: {}
          };

        case 2:
          return {
            params: args[0],
            values: args[1],
            actionCreatorOptions: {}
          };

        default:
          return {
            params: args[0],
            values: args[1],
            actionCreatorOptions: args[2]
          };
      }
    } else {
      switch (definedArgs) {
        case 1:
          return {
            params: args[0],
            values: {},
            actionCreatorOptions: {}
          };

        case 2:
          return {
            params: args[0],
            values: args[1],
            actionCreatorOptions: {}
          };

        default:
          return {
            params: args[0],
            values: args[1],
            actionCreatorOptions: args[2]
          };
      }
    }
  } else {
    switch (definedArgs) {
      case 1:
        return {
          params: args[0],
          actionCreatorOptions: {}
        };

      case 2:
        return {
          params: args[0],
          actionCreatorOptions: args[1] || {}
        };

      default:
        return {
          params: args[0],
          actionCreatorOptions: args[2] || {}
        };
    }
  }
}

function getNumberOfArguments(args) {
  var argsInReverse = args.slice().reverse();

  for (var index = 0; index < argsInReverse.length; index++) {
    var element = argsInReverse[index];

    if (!(0, _isUndefined["default"])(element)) {
      return args.length - index;
    }
  }

  return args.length;
}

var _default = adaptOptionsForSingularResource;
exports["default"] = _default;