"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _arrayFrom = _interopRequireDefault(require("../../utils/array/arrayFrom"));

var _getListKey = _interopRequireDefault(require("./getListKey"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function getListKeys(listKeys, urlOnlyParams) {
  return (0, _arrayFrom["default"])(listKeys).map(function (listKey) {
    return (0, _getListKey["default"])(listKey, {
      urlOnlyParams: urlOnlyParams
    });
  });
}

function extractListOperations(actionCreatorOptions, urlOnlyParams) {
  var push = actionCreatorOptions.push,
      unshift = actionCreatorOptions.unshift,
      invalidate = actionCreatorOptions.invalidate,
      _actionCreatorOptions = actionCreatorOptions.merge,
      merge = _actionCreatorOptions === void 0 ? [] : _actionCreatorOptions;
  return {
    push: getListKeys(push, urlOnlyParams),
    unshift: getListKeys(unshift, urlOnlyParams),
    invalidate: getListKeys(invalidate, urlOnlyParams),
    merge: merge.map(function (mergerKeyPair) {
      var _mergerKeyPair = _slicedToArray(mergerKeyPair, 2),
          keys = _mergerKeyPair[0],
          merger = _mergerKeyPair[1];

      return [getListKeys(keys), merger];
    }),
    sort: merge.map(function (sorterKeyPair) {
      var _sorterKeyPair = _slicedToArray(sorterKeyPair, 2),
          keys = _sorterKeyPair[0],
          sorter = _sorterKeyPair[1];

      return [getListKeys(keys), sorter];
    })
  };
}

var _default = extractListOperations;
exports["default"] = _default;