"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _isEmpty = _interopRequireDefault(require("../../utils/list/isEmpty"));

var queryString = _interopRequireWildcard(require("query-string"));

var _without = _interopRequireDefault(require("../../utils/list/without"));

var _isObject = _interopRequireDefault(require("../../utils/object/isObject"));

var _arrayFrom = _interopRequireDefault(require("../../utils/array/arrayFrom"));

var _configuration = require("../../configuration");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function generateUrl(_ref) {
  var urlTemplate = _ref.urlTemplate,
      keyBy = _ref.keyBy,
      _ref$ignoreOptionalPa = _ref.ignoreOptionalParams,
      ignoreOptionalParams = _ref$ignoreOptionalPa === void 0 ? false : _ref$ignoreOptionalPa;
  var paramValues = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var _insertTemplateParame = insertTemplateParameters(urlTemplate, paramValues, ignoreOptionalParams),
      _insertTemplateParame2 = _slicedToArray(_insertTemplateParame, 2),
      urlBase = _insertTemplateParame2[0],
      paramsUsedInUrl = _insertTemplateParame2[1];

  if ((0, _isObject["default"])(paramValues)) {
    var queryParams = (0, _without["default"])(paramValues, (0, _arrayFrom["default"])(keyBy).concat(paramsUsedInUrl));

    if ((0, _isEmpty["default"])(queryParams)) {
      return urlBase;
    } else {
      return "".concat(urlBase, "?").concat(queryString.stringify(queryParams, (0, _configuration.getConfiguration)().queryStringOptions));
    }
  } else {
    return urlBase;
  }
}

function insertTemplateParameters(evaluatedUrl, paramValues, ignoreOptionalParams) {
  var paramsUsedInUrl = [];
  var isFirstParam = true;
  var urlBase = evaluatedUrl.replace(/:([A-z?]+)/g, function (urlParameter) {
    var paramKey = urlParameter.substring(1);
    var paramIsRequired = true;

    if (paramKey.endsWith('?')) {
      paramKey = paramKey.substring(0, paramKey.length - 1);

      if (ignoreOptionalParams) {
        paramsUsedInUrl.push(paramKey);
        return '';
      } else {
        paramIsRequired = false;
      }
    }

    var paramValue = isFirstParam && !(0, _isObject["default"])(paramValues) ? paramValues : paramValues[paramKey];
    isFirstParam = false;

    if (paramValue) {
      paramsUsedInUrl.push(paramKey);
      return paramValue;
    } else {
      if (paramIsRequired) {
        throw Error("Required url parameter '".concat(paramKey, "' is missing from ").concat(JSON.stringify(paramValues, (0, _configuration.getConfiguration)().queryStringOptions), "."));
      } else {
        return '';
      }
    }
  });

  if (urlBase.endsWith('/')) {
    urlBase = urlBase.substring(0, urlBase.length - 1);
  }

  return [urlBase, paramsUsedInUrl];
}

var _default = generateUrl;
exports["default"] = _default;