"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _serializeKey = _interopRequireDefault(require("../../public-helpers/serializeKey"));

var _isObject = _interopRequireDefault(require("../../utils/object/isObject"));

var _arrayFrom = _interopRequireDefault(require("../../utils/array/arrayFrom"));

var _hasKey = _interopRequireDefault(require("../../utils/object/hasKey"));

var _isUndefined = _interopRequireDefault(require("../../utils/isUndefined"));

var _EmptyKey = _interopRequireDefault(require("../../constants/EmptyKey"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function getItemKey(params, _ref) {
  var keyBy = _ref.keyBy,
      singular = _ref.singular;

  if (singular) {
    return _EmptyKey["default"];
  }

  var _params = (0, _arrayFrom["default"])(params);

  if (Array.isArray(keyBy) && keyBy.length > 1) {
    var keys = keyBy.reduce(function (memo, key) {
      memo[key] = highestPriorityValue(_params, key);
      return memo;
    }, {});
    return (0, _serializeKey["default"])(keys);
  } else {
    return highestPriorityValue(_params, keyBy);
  }
}

function highestPriorityValue(targets, key) {
  var firstMatch = targets.find(function (target) {
    if ((0, _isObject["default"])(target)) {
      return (0, _hasKey["default"])(target, key) && !(0, _isUndefined["default"])(target[key]);
    } else {
      return target;
    }
  });
  return (0, _isObject["default"])(firstMatch) ? firstMatch[key] : firstMatch;
}

var _default = getItemKey;
exports["default"] = _default;