"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _arrayFrom = _interopRequireDefault(require("../../utils/array/arrayFrom"));

var _hasKey = _interopRequireDefault(require("../../utils/object/hasKey"));

var _isObject = _interopRequireDefault(require("../../utils/object/isObject"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function resolveOptions() {
  for (var _len = arguments.length, options = new Array(_len), _key = 0; _key < _len; _key++) {
    options[_key] = arguments[_key];
  }

  var attributes = options.pop();
  var prioritisedOptions = options.reverse();
  return (0, _arrayFrom["default"])(attributes).reduce(function (memo, attributeName) {
    var highestPriorityOption = prioritisedOptions.find(function (args) {
      return (0, _isObject["default"])(args) && (0, _hasKey["default"])(args, attributeName);
    });

    if (highestPriorityOption) {
      memo[attributeName] = highestPriorityOption[attributeName];
    }

    return memo;
  }, {});
}

var _default = resolveOptions;
exports["default"] = _default;