"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Statuses = require("../constants/Statuses");

function requestProgress(options, _ref) {
  var direction = _ref.direction,
      loaded = _ref.loaded,
      total = _ref.total,
      lengthComputable = _ref.lengthComputable;
  var action = options.action,
      key = options.key;

  var percent = function () {
    if (lengthComputable) {
      if (total) {
        return loaded / total * 100;
      } else {
        return 100;
      }
    } else {
      return -1;
    }
  }();

  return {
    type: action,
    status: _Statuses.PROGRESS,
    key: key,
    loaded: loaded,
    total: total,
    direction: direction,
    lengthComputable: lengthComputable,
    percent: percent
  };
}

var _default = requestProgress;
exports["default"] = _default;