"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Statuses = require("../../constants/Statuses");

var _getItemKey = _interopRequireDefault(require("../../action-creators/helpers/getItemKey"));

var _wrapInObject = _interopRequireDefault(require("../../utils/object/wrapInObject"));

var _mergeStatus = _interopRequireDefault(require("../../reducers/helpers/mergeStatus"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function actionCreator(options, params) {
  var action = options.action,
      keyBy = options.keyBy,
      singular = options.singular;
  var normalizedParams = (0, _wrapInObject["default"])(params, keyBy);
  var key = (0, _getItemKey["default"])(normalizedParams, {
    keyBy: keyBy,
    singular: singular
  });
  return {
    type: action,
    key: key
  };
}

function reducer(resources, action) {
  var key = action.key;
  var items = resources.items;
  var currentItem = items[key];

  if (currentItem && (currentItem.status.type === _Statuses.EDITING || currentItem.status.type === _Statuses.ERROR && currentItem.status.originalValues)) {
    var newValues = function () {
      if (currentItem.status.dirty) {
        return currentItem.status.originalValues;
      } else {
        return currentItem.values;
      }
    }();

    return _objectSpread(_objectSpread({}, resources), {}, {
      items: _objectSpread(_objectSpread({}, items), {}, _defineProperty({}, key, _objectSpread(_objectSpread({}, currentItem), {}, {
        status: (0, _mergeStatus["default"])(currentItem.status, {
          type: _Statuses.SUCCESS
        }, {
          onlyPersist: ['syncedAt', 'requestedAt']
        }),
        values: newValues
      })))
    });
  } else {
    return resources;
  }
}

var _default = {
  reducer: reducer,
  actionCreator: actionCreator
};
exports["default"] = _default;