"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Statuses = require("../../constants/Statuses");

var _without = _interopRequireDefault(require("../../utils/list/without"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function actionCreator(_ref) {
  var action = _ref.action;
  return {
    type: action
  };
}

function reducer(resources) {
  var newItemKey = resources.newItemKey,
      items = resources.items,
      lists = resources.lists,
      selectionMap = resources.selectionMap;

  if (items[newItemKey] && items[newItemKey].status.type === _Statuses.NEW) {
    return _objectSpread(_objectSpread({}, resources), {}, {
      items: (0, _without["default"])(items, newItemKey),
      lists: Object.keys(lists).reduce(function (memo, key) {
        var list = lists[key];
        memo[key] = _objectSpread(_objectSpread({}, list), {}, {
          positions: (0, _without["default"])(list.positions, newItemKey)
        });
        return memo;
      }, {}),
      selectionMap: (0, _without["default"])(selectionMap, newItemKey),
      newItemKey: null
    });
  } else {
    return _objectSpread(_objectSpread({}, resources), {}, {
      newItemKey: null
    });
  }
}

var _default = {
  reducer: reducer,
  actionCreator: actionCreator
};
exports["default"] = _default;