"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _without = _interopRequireDefault(require("../../utils/list/without"));

var _wrapInObject = _interopRequireDefault(require("../../utils/object/wrapInObject"));

var _getListKey = _interopRequireDefault(require("../../action-creators/helpers/getListKey"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function actionCreator(_ref, params) {
  var action = _ref.action,
      keyBy = _ref.keyBy;
  var normalizedParams = (0, _wrapInObject["default"])(params, keyBy);
  var key = (0, _getListKey["default"])(normalizedParams);
  return {
    type: action,
    key: key
  };
}

function reducer(resources, action) {
  var key = action.key;
  var lists = resources.lists;

  if (lists[key]) {
    return _objectSpread(_objectSpread({}, resources), {}, {
      lists: (0, _without["default"])(lists, key)
    });
  } else {
    return resources;
  }
}

var _default = {
  reducer: reducer,
  actionCreator: actionCreator
};
exports["default"] = _default;