"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _getItemKey = _interopRequireDefault(require("../../action-creators/helpers/getItemKey"));

var _without = _interopRequireDefault(require("../../utils/list/without"));

var _wrapInObject = _interopRequireDefault(require("../../utils/object/wrapInObject"));

var _arrayFrom = _interopRequireDefault(require("../../utils/array/arrayFrom"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function actionCreator(_ref, params) {
  var action = _ref.action,
      keyBy = _ref.keyBy,
      singular = _ref.singular;
  var keys = (0, _arrayFrom["default"])(params).map(function (itemParams) {
    return (0, _getItemKey["default"])((0, _wrapInObject["default"])(itemParams, keyBy), {
      keyBy: keyBy,
      singular: singular
    });
  });
  return {
    type: action,
    keys: keys
  };
}

function reducer(resources, action) {
  var keys = action.keys;
  return _objectSpread(_objectSpread({}, resources), {}, {
    selectionMap: (0, _without["default"])(resources.selectionMap, keys)
  });
}

var _default = {
  reducer: reducer,
  actionCreator: actionCreator
};
exports["default"] = _default;