"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _warn = _interopRequireDefault(require("../../utils/dev/warn"));

var _getItemKey = _interopRequireDefault(require("../../action-creators/helpers/getItemKey"));

var _wrapInObject = _interopRequireDefault(require("../../utils/object/wrapInObject"));

var _arrayFrom = _interopRequireDefault(require("../../utils/array/arrayFrom"));

var _hasKey = _interopRequireDefault(require("../../utils/object/hasKey"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function actionCreator(_ref, params) {
  var action = _ref.action,
      keyBy = _ref.keyBy,
      singular = _ref.singular;
  var actionCreatorOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var keys = (0, _arrayFrom["default"])(params).map(function (itemParams) {
    return (0, _getItemKey["default"])((0, _wrapInObject["default"])(itemParams, keyBy), {
      keyBy: keyBy,
      singular: singular
    });
  });
  return {
    type: action,
    keys: keys,
    values: (0, _arrayFrom["default"])(actionCreatorOptions.value || actionCreatorOptions.values || Array(keys.length).fill(true))
  };
}

function reducer(resources, action) {
  var type = action.type,
      keys = action.keys,
      values = action.values;
  var newSelectionMap = keys.reduce(function (memo, key, index) {
    var value = values[index];

    if ((0, _hasKey["default"])(resources.items, key)) {
      return _objectSpread(_objectSpread({}, memo), {}, _defineProperty({}, key, value));
    } else {
      (0, _warn["default"])("selectMap is not intended to hold references to items that are not in the store. ".concat(type, "'s key ") + "'".concat(key, "' did not match any of the item keys: ").concat(Object.keys(resources.items).join(', '), ". Check the ") + 'options passed to selectAnotherItem(). (The selection was ignored.)');
      return memo;
    }
  }, {});
  return _objectSpread(_objectSpread({}, resources), {}, {
    selectionMap: _objectSpread(_objectSpread({}, resources.selectionMap), newSelectionMap)
  });
}

var _default = {
  reducer: reducer,
  actionCreator: actionCreator
};
exports["default"] = _default;