"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _InitialStateBuilder2 = _interopRequireDefault(require("./InitialStateBuilder"));

var _getItemKey = _interopRequireDefault(require("../action-creators/helpers/getItemKey"));

var _InitialItemStateBuilder = _interopRequireDefault(require("./InitialItemStateBuilder"));

var _DataStructures = require("../constants/DataStructures");

var _MetadataTypes = require("../constants/MetadataTypes");

var _Statuses = require("../constants/Statuses");

var _extractVariableArguments = _interopRequireDefault(require("../utils/extractVariableArguments"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var InitialListStateBuilder = function (_InitialStateBuilder) {
  _inherits(InitialListStateBuilder, _InitialStateBuilder);

  var _super = _createSuper(InitialListStateBuilder);

  function InitialListStateBuilder(options) {
    var _this;

    var items = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

    _classCallCheck(this, InitialListStateBuilder);

    _this = _super.call(this, options);
    _this.items = {};
    _this.positions = [];
    items.forEach(function (item) {
      return _this.addItem(item);
    });
    return _this;
  }

  _createClass(InitialListStateBuilder, [{
    key: "addItem",
    value: function addItem(paramsOrValues, optionalItems) {
      var _extractVariableArgum = (0, _extractVariableArguments["default"])(['params', 'values'], [paramsOrValues, optionalItems]),
          values = _extractVariableArgum.values,
          _extractVariableArgum2 = _extractVariableArgum.params,
          params = _extractVariableArgum2 === void 0 ? {} : _extractVariableArgum2;

      var key = (0, _getItemKey["default"])([params, values], {
        keyBy: this.options.keyBy
      });
      var itemStateBuilder = new _InitialItemStateBuilder["default"](this.options, values);
      this.items[key] = itemStateBuilder;
      this.positions.push(key);
      return itemStateBuilder;
    }
  }, {
    key: "build",
    value: function build(_ref) {
      var _ref$status = _ref.status,
          status = _ref$status === void 0 ? {} : _ref$status,
          _ref$metadata = _ref.metadata,
          metadata = _ref$metadata === void 0 ? {} : _ref$metadata;
      return _objectSpread(_objectSpread({}, _DataStructures.LIST), {}, {
        positions: this.positions,
        status: _objectSpread(_objectSpread({
          type: _Statuses.SUCCESS
        }, status), this.status),
        metadata: _objectSpread(_objectSpread({
          type: _MetadataTypes.COMPLETE
        }, metadata), this.metadata)
      });
    }
  }, {
    key: "buildItems",
    value: function buildItems(_ref2) {
      var _this2 = this;

      var _ref2$status = _ref2.status,
          status = _ref2$status === void 0 ? {} : _ref2$status,
          metadata = _ref2.metadata;
      return Object.keys(this.items).reduce(function (memo, key) {
        var item = _this2.items[key];
        return _objectSpread(_objectSpread({}, memo), {}, _defineProperty({}, key, item.build({
          status: _objectSpread(_objectSpread({}, status), _this2.status),
          metadata: _objectSpread(_objectSpread({
            type: _MetadataTypes.COMPLETE
          }, metadata), _this2.metadata)
        })));
      }, {});
    }
  }]);

  return InitialListStateBuilder;
}(_InitialStateBuilder2["default"]);

var _default = InitialListStateBuilder;
exports["default"] = _default;