"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _InitialListStateBuilder = _interopRequireDefault(require("./InitialListStateBuilder"));

var _EmptyKey = _interopRequireDefault(require("../constants/EmptyKey"));

var _InitialStateBuilder2 = _interopRequireDefault(require("./InitialStateBuilder"));

var _isEmpty = _interopRequireDefault(require("../utils/list/isEmpty"));

var _DataStructures = require("../constants/DataStructures");

var _extractVariableArguments = _interopRequireDefault(require("../utils/extractVariableArguments"));

var _getItemKey = _interopRequireDefault(require("../action-creators/helpers/getItemKey"));

var _getListKey = _interopRequireDefault(require("../action-creators/helpers/getListKey"));

var _InitialItemStateBuilder = _interopRequireDefault(require("./InitialItemStateBuilder"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var InitialResourceStateBuilder = function (_InitialStateBuilder) {
  _inherits(InitialResourceStateBuilder, _InitialStateBuilder);

  var _super = _createSuper(InitialResourceStateBuilder);

  function InitialResourceStateBuilder(options) {
    var _this;

    var items = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

    _classCallCheck(this, InitialResourceStateBuilder);

    _this = _super.call(this, options);
    _this.lists = {};
    _this.items = {};

    if (!(0, _isEmpty["default"])(items)) {
      _this.addList(items);
    }

    return _this;
  }

  _createClass(InitialResourceStateBuilder, [{
    key: "addList",
    value: function addList(itemsOrParams, optionalItems) {
      var _extractVariableArgum = (0, _extractVariableArguments["default"])(['params', 'items'], [itemsOrParams, optionalItems]),
          items = _extractVariableArgum.items,
          _extractVariableArgum2 = _extractVariableArgum.params,
          params = _extractVariableArgum2 === void 0 ? _EmptyKey["default"] : _extractVariableArgum2;

      var listStateBuilder = new _InitialListStateBuilder["default"](this.options, items);
      var key = (0, _getListKey["default"])(params);
      this.lists[key] = listStateBuilder;
      return listStateBuilder;
    }
  }, {
    key: "addItem",
    value: function addItem(paramsOrValues, optionalValues) {
      var _extractVariableArgum3 = (0, _extractVariableArguments["default"])(['params', 'values'], [paramsOrValues, optionalValues]),
          values = _extractVariableArgum3.values,
          _extractVariableArgum4 = _extractVariableArgum3.params,
          params = _extractVariableArgum4 === void 0 ? {} : _extractVariableArgum4;

      var key = (0, _getItemKey["default"])([params, values], {
        keyBy: this.options.keyBy,
        singular: this.options.singular
      });
      var itemStateBuilder = new _InitialItemStateBuilder["default"](this.options, values);
      this.items[key] = itemStateBuilder;
      return itemStateBuilder;
    }
  }, {
    key: "build",
    value: function build() {
      var _this2 = this;

      var itemsOutsideOfLists = Object.keys(this.items).reduce(function (memo, key) {
        var item = _this2.items[key];
        memo[key] = item.build({
          status: _this2.status,
          metadata: _this2.metadata
        });
        return memo;
      }, {});
      var itemsFromLists = Object.values(this.lists).reduce(function (memo, list) {
        return _objectSpread(_objectSpread({}, memo), list.buildItems({
          status: _this2.status,
          metadata: _this2.metadata
        }));
      }, {});
      return _objectSpread(_objectSpread({}, _DataStructures.RESOURCES), {}, {
        items: _objectSpread(_objectSpread({}, itemsOutsideOfLists), itemsFromLists),
        lists: Object.keys(this.lists).reduce(function (memo, key) {
          var list = _this2.lists[key];
          memo[key] = list.build({
            status: _this2.status,
            metadata: _this2.metadata
          });
          return memo;
        }, {})
      });
    }
  }]);

  return InitialResourceStateBuilder;
}(_InitialStateBuilder2["default"]);

var _default = InitialResourceStateBuilder;
exports["default"] = _default;