"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "isNew", {
  enumerable: true,
  get: function get() {
    return _isNew["default"];
  }
});
Object.defineProperty(exports, "serializeKey", {
  enumerable: true,
  get: function get() {
    return _serializeKey["default"];
  }
});
Object.defineProperty(exports, "configure", {
  enumerable: true,
  get: function get() {
    return _configuration.setConfiguration;
  }
});
Object.defineProperty(exports, "getConfiguration", {
  enumerable: true,
  get: function get() {
    return _configuration.getConfiguration;
  }
});
Object.defineProperty(exports, "canFallbackToOldValues", {
  enumerable: true,
  get: function get() {
    return _canFallbackToOldValues["default"];
  }
});
Object.defineProperty(exports, "getTimeSinceFetchStarted", {
  enumerable: true,
  get: function get() {
    return _getTimeSinceFetchStarted["default"];
  }
});
Object.defineProperty(exports, "getTimeSinceLastSync", {
  enumerable: true,
  get: function get() {
    return _getTimeSinceLastSync["default"];
  }
});
Object.defineProperty(exports, "getValuesBeforeEditing", {
  enumerable: true,
  get: function get() {
    return _getValuesBeforeEditing["default"];
  }
});
Object.defineProperty(exports, "getHttpStatusCode", {
  enumerable: true,
  get: function get() {
    return _getHttpStatusCode["default"];
  }
});
Object.defineProperty(exports, "isNewItemKey", {
  enumerable: true,
  get: function get() {
    return _isNewItemKey["default"];
  }
});
Object.defineProperty(exports, "isEdited", {
  enumerable: true,
  get: function get() {
    return _isEdited["default"];
  }
});
Object.defineProperty(exports, "isSuccess", {
  enumerable: true,
  get: function get() {
    return _isSuccess["default"];
  }
});
Object.defineProperty(exports, "isError", {
  enumerable: true,
  get: function get() {
    return _isError["default"];
  }
});
exports.isFinishedSyncing = exports.isFinishedSaving = exports.isNotAvailableLocally = exports.isFinishedUpdating = exports.isFinishedCreating = exports.isFinishedFetching = exports.isSyncing = exports.isSaving = exports.isDestroying = exports.isUpdating = exports.isCreating = exports.isFetching = exports.isFetched = exports.isCreated = void 0;

var _Statuses = require("../constants/Statuses");

var _isStatus = _interopRequireDefault(require("./isStatus"));

var _isFinished = _interopRequireDefault(require("./isFinished"));

var _isNew = _interopRequireDefault(require("./isNew"));

var _isUndefined = _interopRequireDefault(require("../utils/isUndefined"));

var _serializeKey = _interopRequireDefault(require("./serializeKey"));

var _configuration = require("../configuration");

var _canFallbackToOldValues = _interopRequireDefault(require("./canFallbackToOldValues"));

var _getTimeSinceFetchStarted = _interopRequireDefault(require("./getTimeSinceFetchStarted"));

var _getTimeSinceLastSync = _interopRequireDefault(require("./getTimeSinceLastSync"));

var _getValuesBeforeEditing = _interopRequireDefault(require("./getValuesBeforeEditing"));

var _getHttpStatusCode = _interopRequireDefault(require("./getHttpStatusCode"));

var _isNewItemKey = _interopRequireDefault(require("./isNewItemKey"));

var _isEdited = _interopRequireDefault(require("./isEdited"));

var _isSuccess = _interopRequireDefault(require("./isSuccess"));

var _isError = _interopRequireDefault(require("./isError"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var isCreated = function isCreated(item) {
  return !(0, _isNew["default"])(item);
};

exports.isCreated = isCreated;

var isFetched = function isFetched(item) {
  return !(0, _isNew["default"])(item);
};

exports.isFetched = isFetched;

var isFetching = function isFetching(itemOrList) {
  return (0, _isStatus["default"])(itemOrList, _Statuses.FETCHING);
};

exports.isFetching = isFetching;

var isCreating = function isCreating(itemOrList) {
  return (0, _isStatus["default"])(itemOrList, _Statuses.CREATING);
};

exports.isCreating = isCreating;

var isUpdating = function isUpdating(itemOrList) {
  return (0, _isStatus["default"])(itemOrList, _Statuses.UPDATING);
};

exports.isUpdating = isUpdating;

var isDestroying = function isDestroying(itemOrList) {
  return (0, _isStatus["default"])(itemOrList, _Statuses.DESTROYING);
};

exports.isDestroying = isDestroying;

var isSaving = function isSaving(itemOrList) {
  return (0, _isStatus["default"])(itemOrList, [_Statuses.CREATING, _Statuses.UPDATING]);
};

exports.isSaving = isSaving;

var isSyncing = function isSyncing(itemOrList) {
  return (0, _isStatus["default"])(itemOrList, [_Statuses.FETCHING, _Statuses.CREATING, _Statuses.UPDATING, _Statuses.DESTROYING, _Statuses.SYNCING, _Statuses.PROGRESS]);
};

exports.isSyncing = isSyncing;

var isFinishedFetching = function isFinishedFetching(itemOrList) {
  return (0, _isFinished["default"])(itemOrList, _Statuses.FETCHING);
};

exports.isFinishedFetching = isFinishedFetching;

var isFinishedCreating = function isFinishedCreating(itemOrList) {
  return (0, _isFinished["default"])(itemOrList, _Statuses.CREATING);
};

exports.isFinishedCreating = isFinishedCreating;

var isFinishedUpdating = function isFinishedUpdating(itemOrList) {
  return (0, _isFinished["default"])(itemOrList, _Statuses.UPDATING);
};

exports.isFinishedUpdating = isFinishedUpdating;

var isNotAvailableLocally = function isNotAvailableLocally(itemOrList) {
  return (0, _isUndefined["default"])(itemOrList) || itemOrList === null || (0, _isStatus["default"])(itemOrList, [null]);
};

exports.isNotAvailableLocally = isNotAvailableLocally;

var isFinishedSaving = function isFinishedSaving(itemOrList) {
  return (0, _isFinished["default"])(itemOrList, [_Statuses.CREATING, _Statuses.UPDATING]);
};

exports.isFinishedSaving = isFinishedSaving;

var isFinishedSyncing = function isFinishedSyncing(itemOrList) {
  return (0, _isFinished["default"])(itemOrList, [_Statuses.FETCHING, _Statuses.CREATING, _Statuses.UPDATING, _Statuses.DESTROYING, _Statuses.SYNCING, _Statuses.PROGRESS]);
};

exports.isFinishedSyncing = isFinishedSyncing;