"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ProgressDirections = require("../../constants/ProgressDirections");

var _Statuses = require("../../constants/Statuses");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function progressReducer(resources, action) {
  var attr = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'items';
  var temporaryKey = action.temporaryKey,
      key = action.key;

  var _key = temporaryKey || key;

  var progressAttributes = function () {
    if (action.status === _Statuses.PROGRESS) {
      var percent = action.percent,
          total = action.total,
          loaded = action.loaded,
          lengthComputable = action.lengthComputable,
          direction = action.direction;
      return {
        percent: percent,
        total: total,
        loaded: loaded,
        lengthComputable: lengthComputable,
        direction: direction
      };
    } else if (action.status === _Statuses.SUCCESS) {
      var _resources$attr$_key$ = resources[attr][_key].status.progressDown,
          _total = _resources$attr$_key$.total,
          _lengthComputable = _resources$attr$_key$.lengthComputable;
      return {
        percent: 100,
        total: _total,
        loaded: _total,
        lengthComputable: _lengthComputable,
        direction: _ProgressDirections.DOWN
      };
    } else {
      return null;
    }
  }();

  if (progressAttributes) {
    return _objectSpread(_objectSpread({}, resources), {}, _defineProperty({}, attr, _objectSpread(_objectSpread({}, resources[attr]), {}, _defineProperty({}, _key, updateProgress(resources[attr][_key], progressAttributes)))));
  } else {
    return resources;
  }
}

function updateProgress(resource, _ref) {
  var percent = _ref.percent,
      total = _ref.total,
      loaded = _ref.loaded,
      lengthComputable = _ref.lengthComputable,
      direction = _ref.direction;

  var progressAttributes = function () {
    if (direction === _ProgressDirections.UP) {
      return {
        progressUp: {
          total: total,
          loaded: loaded,
          percent: percent,
          lengthComputable: lengthComputable
        }
      };
    } else {
      return {
        progressDown: {
          total: total,
          loaded: loaded,
          percent: percent,
          lengthComputable: lengthComputable
        }
      };
    }
  }();

  return _objectSpread(_objectSpread({}, resource), {}, {
    status: _objectSpread(_objectSpread({
      progressUp: {
        percent: 0,
        loaded: 0,
        total: undefined,
        lengthComputable: undefined
      },
      progressDown: {
        percent: 0,
        loaded: 0,
        total: undefined,
        lengthComputable: undefined
      }
    }, resource.status), progressAttributes)
  });
}

var _default = progressReducer;
exports["default"] = _default;