"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var UploadMock = function UploadMock() {
  _classCallCheck(this, UploadMock);

  this.onprogress = null;
  this.onloadend = null;
};

var ResponseMock = function ResponseMock(options) {
  _classCallCheck(this, ResponseMock);

  this.options = options;
};

var MockManager = function () {
  function MockManager() {
    var request = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
    var response = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

    _classCallCheck(this, MockManager);

    this.request = request;
    this.response = response;
  }

  _createClass(MockManager, [{
    key: "setRequest",
    value: function setRequest(request) {
      this.request = request;
    }
  }, {
    key: "setResponse",
    value: function setResponse(response) {
      this.response = response;
    }
  }, {
    key: "setUploadProgress",
    value: function setUploadProgress(progressEvent) {
      var request = this._getRequest('setProgress');

      if (request.upload.onprogress) {
        request.upload.onprogress(progressEvent);
      } else {
        throw new Error("setProgress called on request ".concat(request.url, " that does not have an onprogress handler set"));
      }
    }
  }, {
    key: "completeUpload",
    value: function completeUpload(target) {
      var request = this._getRequest('completeUpload');

      var requestBody = JSON.stringify(request.body);
      var requestLength = requestBody ? requestBody.length : 0;

      if (request.upload.onload) {
        request.upload.onload({
          target: target
        });
      }

      if (request.upload.onloadend) {
        request.upload.onloadend({
          target: target,
          lengthComputable: true,
          loaded: requestLength,
          total: requestLength
        });
      }
    }
  }, {
    key: "setDownloadProgress",
    value: function setDownloadProgress(progressEvent) {
      var request = this._getRequest('setProgress');

      if (request.onprogress) {
        request.onprogress(progressEvent);
      } else {
        throw new Error("setProgress called on request ".concat(request.url, " that does not have an onprogress handler set"));
      }
    }
  }, {
    key: "completeDownload",
    value: function completeDownload() {
      var request = this._getRequest('sendResponse');

      var _this$response$option = this.response.options,
          body = _this$response$option.body,
          _responseOptions = _objectWithoutProperties(_this$response$option, ["body"]);

      var responseText = JSON.stringify(body);

      var target = _objectSpread({
        status: 200,
        statusText: 'OK',
        responseType: 'application/json',
        responseText: responseText
      }, _responseOptions);

      if (request.onload) {
        return request.onload({
          target: target
        });
      }
    }
  }, {
    key: "_getRequest",
    value: function _getRequest(caller) {
      if (this.request) {
        return this.request;
      } else {
        throw Error("".concat(caller, " called on MockManager before request was made"));
      }
    }
  }]);

  return MockManager;
}();

var DEFAULT_MOCK_MANAGER_DICT = {
  POST: {},
  GET: {},
  PUT: {},
  DELETE: {}
};

var mockManagersDict = _objectSpread({}, DEFAULT_MOCK_MANAGER_DICT);

var XHRMock = function () {
  _createClass(XHRMock, null, [{
    key: "setup",
    value: function setup() {
      this.realXHR = global.XMLHttpRequest;
      global.XMLHttpRequest = XHRMock;
    }
  }, {
    key: "reset",
    value: function reset() {
      mockManagersDict = _objectSpread({}, DEFAULT_MOCK_MANAGER_DICT);
    }
  }, {
    key: "tearDown",
    value: function tearDown() {
      global.XMLHttpRequest = this.realXHR;
    }
  }, {
    key: "post",
    value: function post(url, options) {
      var mockManager = new MockManager();
      mockManager.setResponse(new ResponseMock(options));
      mockManagersDict.POST[url] = mockManager;
      return mockManager;
    }
  }, {
    key: "put",
    value: function put(url, options) {
      var mockManager = new MockManager();
      mockManager.setResponse(new ResponseMock(options));
      mockManagersDict.PUT[url] = mockManager;
      return mockManager;
    }
  }, {
    key: "get",
    value: function get(url, options) {
      var mockManager = new MockManager();
      mockManager.setResponse(new ResponseMock(options));
      mockManagersDict.GET[url] = mockManager;
      return mockManager;
    }
  }]);

  function XHRMock() {
    _classCallCheck(this, XHRMock);

    this.withCredentials = false;
    this.headers = {};
    this.upload = new UploadMock();
    this.response = null;
    this.onload = null;
    this.onerror = null;
  }

  _createClass(XHRMock, [{
    key: "open",
    value: function open(method, url) {
      this.method = method;
      this.url = url;
      var mockManager = mockManagersDict[method][url];

      if (mockManager) {
        mockManager.setRequest(this);
      } else {
        throw new Error("Received unexpected ".concat(method, " request for ").concat(url, "."));
      }
    }
  }, {
    key: "setRequestHeader",
    value: function setRequestHeader(key, value) {
      this.headers[key] = value;
    }
  }, {
    key: "send",
    value: function send(body) {
      this.body = body;
    }
  }]);

  return XHRMock;
}();

var _default = XHRMock;
exports["default"] = _default;