"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.expectToChangeNewItemKeyTo = expectToChangeNewItemKeyTo;
exports.expectToNotChangeNewItemKey = expectToNotChangeNewItemKey;
exports.expectToChangeSelectionMapTo = expectToChangeSelectionMapTo;
exports.expectToNotChangeSelectionMap = expectToNotChangeSelectionMap;
exports.setupInitialState = setupInitialState;
exports.expectToChangeResourceItemStatusTo = expectToChangeResourceItemStatusTo;
exports.expectToClearResourceItemStatus = expectToClearResourceItemStatus;
exports.expectToChangeResourceItemValuesTo = expectToChangeResourceItemValuesTo;
exports.expectToChangeResourceItemStatusErrorOccurredAtToBeSet = expectToChangeResourceItemStatusErrorOccurredAtToBeSet;
exports.expectToNotChangeResourceItemStatus = expectToNotChangeResourceItemStatus;
exports.expectToNotChangeResourceItemValues = expectToNotChangeResourceItemValues;
exports.expectToNotChangeResourceItem = expectToNotChangeResourceItem;
exports.resourceItem = resourceItem;
exports.resourceDefinition = resourceDefinition;
exports.expectToChangeResourcesItemStatusTo = expectToChangeResourcesItemStatusTo;
exports.expectToClearResourcesItemStatus = expectToClearResourcesItemStatus;
exports.expectToChangeResourcesItemStatusErrorOccurredAtToBeSet = expectToChangeResourcesItemStatusErrorOccurredAtToBeSet;
exports.expectToChangeResourcesItemValuesTo = expectToChangeResourcesItemValuesTo;
exports.expectToClearResourcesItemValues = expectToClearResourcesItemValues;
exports.expectToClearResourcesListStatus = expectToClearResourcesListStatus;
exports.expectToChangeResourceListStatusTo = expectToChangeResourceListStatusTo;
exports.expectToChangeResourceListPositionsTo = expectToChangeResourceListPositionsTo;
exports.expectToChangeResourcesListStatusErrorOccurredAtToBeSet = expectToChangeResourcesListStatusErrorOccurredAtToBeSet;
exports.expectToNotChangeResourcesItemValues = expectToNotChangeResourcesItemValues;
exports.expectToNotChangeResourcesItemStatus = expectToNotChangeResourcesItemStatus;
exports.expectToNotChangeResourcesItem = expectToNotChangeResourcesItem;
exports.expectToNotChangeResourceListStatus = expectToNotChangeResourceListStatus;
exports.expectToNotChangeResourceListPositions = expectToNotChangeResourceListPositions;
exports.expectToNotChangeResourcesList = expectToNotChangeResourcesList;
exports.expectToNotChangeResources = expectToNotChangeResources;
exports.resourcesItem = resourcesItem;
exports.resourcesList = resourcesList;
exports.resourcesDefinition = resourcesDefinition;

var _EmptyKey = _interopRequireDefault(require("../../constants/EmptyKey"));

var _isUndefined = _interopRequireDefault(require("../../utils/isUndefined"));

var _buildStore3 = _interopRequireDefault(require("./buildStore"));

var _ = require("../..");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function expectToChangeNewItemKeyTo(context, resourceName, value) {
  expect(resourceDefinition(context, resourceName).newItemKey).toEqual(value);
}

function expectToNotChangeNewItemKey(context, resourceName) {
  expect(resourceDefinition(context, resourceName).newItemKey).toEqual(context.initialState.newItemKey);
}

function expectToChangeSelectionMapTo(context, resourceName, value) {
  expect(resourceDefinition(context, resourceName).selectionMap).toEqual(value);
}

function expectToNotChangeSelectionMap(context, resourceName) {
  expect(resourceDefinition(context, resourceName).selectionMap).toEqual(context.initialState.selectionMap);
}

function setupInitialState(context, resourceName, initialState) {
  context.initialState = initialState;
  context.store = (0, _buildStore3["default"])(_defineProperty({}, resourceName, _objectSpread(_objectSpread({}, _.RESOURCES), initialState)), _defineProperty({}, resourceName, context.reducers));
}

function expectToChangeResourceItemStatusTo(context, resourcesName, subkeyOrExpectedValue) {
  var expectedValue = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
  expectToChangeResourceItemTo(context, resourcesName, 'status', subkeyOrExpectedValue, expectedValue);
}

function expectToClearResourceItemStatus(context, resourcesName, subkey) {
  var newValue = resourceItem(context, resourcesName).status[subkey];
  expect(newValue).toEqual(undefined);
}

function expectToChangeResourceItemValuesTo(context, resourcesName, subkeyOrExpectedValue) {
  var expectedValue = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
  expectToChangeResourceItemTo(context, resourcesName, 'values', subkeyOrExpectedValue, expectedValue);
}

function expectToChangeResourceItemTo(context, resourcesName, key, subkeyOrExpectedValue) {
  var expectedValue = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : undefined;
  expectResourcesItemToChangeTo(context, resourcesName, _EmptyKey["default"], key, subkeyOrExpectedValue, expectedValue);
}

function expectToChangeResourceItemStatusErrorOccurredAtToBeSet(context, resourceName) {
  expectToChangeResourcesItemStatusErrorOccurredAtToBeSet(context, resourceName, _EmptyKey["default"]);
}

function expectToNotChangeResourceItemStatus(context, resourcesName) {
  var value = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;
  expectToNotChangeResourceItem(context, resourcesName, 'status', value);
}

function expectToNotChangeResourceItemValues(context, resourcesName) {
  var value = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;
  expectToNotChangeResourceItem(context, resourcesName, 'values', value);
}

function expectToNotChangeResourceItem(context, resourcesName, key) {
  var subkey = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
  expectToNotChangeResourcesItem(context, resourcesName, _EmptyKey["default"], key, subkey);
}

function resourceItem(context, resourcesName) {
  return resourcesItem(context, resourcesName, _EmptyKey["default"]);
}

function resourceDefinition(context, resourceName) {
  return resourcesDefinition(context, resourceName);
}

function expectToChangeResourcesItemStatusTo(context, resourcesName, id, subkeyOrExpectedValue) {
  var expectedValue = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : undefined;
  expectResourcesItemToChangeTo(context, resourcesName, id, 'status', subkeyOrExpectedValue, expectedValue);
}

function expectToClearResourcesItemStatus(context, resourcesName, id, subkey) {
  var newValue = resourcesItem(context, resourcesName, id).status[subkey];
  expect(newValue).toEqual(undefined);
}

function expectToChangeResourcesItemStatusErrorOccurredAtToBeSet(context, resourceName, id) {
  expect(resourcesItem(context, resourceName, id).status.errorOccurredAt).not.toBeUndefined();
}

function expectToChangeResourcesItemValuesTo(context, resourcesName, id, subkeyOrExpectedValue) {
  var expectedValue = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : undefined;
  expectResourcesItemToChangeTo(context, resourcesName, id, 'values', subkeyOrExpectedValue, expectedValue);
}

function expectToClearResourcesItemValues(context, resourcesName, id, subkey) {
  var newValue = resourcesItem(context, resourcesName, id).values[subkey];
  expect(newValue).toEqual(undefined);
}

function expectToClearResourcesListStatus(context, resourcesName, id, subkey) {
  var newValue = resourcesDefinition(context, resourcesName).lists[id].status[subkey];
  expect(newValue).toEqual(undefined);
}

function expectToChangeResourceListStatusTo(context, resourcesName, id, subkeyOrExpectedValue) {
  var expectedValue = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : undefined;
  expectResourcesListToChangeTo(context, resourcesName, id, 'status', subkeyOrExpectedValue, expectedValue);
}

function expectToChangeResourceListPositionsTo(context, resourcesName, id, expectedValue) {
  expectResourcesListToChangeTo(context, resourcesName, id, 'positions', expectedValue);
}

function expectToChangeResourcesListStatusErrorOccurredAtToBeSet(context, resourceName, id) {
  expect(resourcesList(context, resourceName, id).status.errorOccurredAt).not.toBeUndefined();
}

function expectResourcesItemToChangeTo(context, resourcesName, id, key, subkeyOrExpectedValue) {
  var expectedValue = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : undefined;
  expectResourcesToChangeTo(context, resourcesName, 'items', id, key, subkeyOrExpectedValue, expectedValue);
}

function expectResourcesListToChangeTo(context, resourcesName, id, key, subkeyOrExpectedValue) {
  var expectedValue = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : undefined;
  expectResourcesToChangeTo(context, resourcesName, 'lists', id, key, subkeyOrExpectedValue, expectedValue);
}

function expectResourcesToChangeTo(context, resourcesName, type, id, key, subkeyOrExpectedValue) {
  var expectedValue = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : undefined;
  var newValue = resourcesDefinition(context, resourcesName)[type][id][key];

  if ((0, _isUndefined["default"])(expectedValue)) {
    expect(newValue).toEqual(subkeyOrExpectedValue);
  } else {
    expect(newValue[subkeyOrExpectedValue]).toEqual(expectedValue);
  }
}

function expectToNotChangeResourcesItemValues(context, resourcesName, id) {
  var value = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
  expectToNotChangeResourcesItem(context, resourcesName, id, 'values', value);
}

function expectToNotChangeResourcesItemStatus(context, resourcesName, id) {
  var value = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
  expectToNotChangeResourcesItem(context, resourcesName, id, 'status', value);
}

function expectToNotChangeResourcesItem(context, resourcesName, id, attribute) {
  var subkey = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : undefined;
  expectToNotChangeResources(context, resourcesName, 'items', id, attribute, subkey);
}

function expectToNotChangeResourceListStatus(context, resourcesName, id, subkeyOrExpectedValue) {
  expectToNotChangeResourcesList(context, resourcesName, id, 'status', subkeyOrExpectedValue);
}

function expectToNotChangeResourceListPositions(context, resourcesName, id) {
  expectToNotChangeResourcesList(context, resourcesName, id, 'positions');
}

function expectToNotChangeResourcesList(context, resourcesName, id) {
  var attribute = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
  var subkey = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : undefined;
  expectToNotChangeResources(context, resourcesName, 'lists', id, attribute, subkey);
}

function expectToNotChangeResources(context, resourcesName, type, id) {
  var attribute = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : undefined;
  var subkey = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : undefined;
  var newValue = resourcesDefinition(context, resourcesName)[type][id];
  var initialValue = (context.initialState[resourcesName] || context.initialState)[type][id];

  if (!(0, _isUndefined["default"])(attribute)) {
    newValue = newValue[attribute];
    initialValue = initialValue[attribute];
  }

  if ((0, _isUndefined["default"])(subkey)) {
    expect(newValue).toEqual(initialValue);
  } else {
    expect(newValue[subkey]).toEqual(initialValue[subkey]);
  }
}

function resourcesItem(context, resourcesName, id) {
  return resourcesDefinition(context, resourcesName).items[id];
}

function resourcesList(context, resourcesName, id) {
  return resourcesDefinition(context, resourcesName).lists[id];
}

function resourcesDefinition(context, resourceName) {
  return context.store.getState()[resourceName];
}