"use strict";

var _buildStore3 = _interopRequireDefault(require("../../helpers/buildStore"));

var _Statuses = require("../../../constants/Statuses");

var _index = require("../../../index");

var _resourceAssertions = require("../../helpers/resourceAssertions");

var _EmptyKey = _interopRequireDefault(require("../../../constants/EmptyKey"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var RESOURCE_NAME = 'users';
describe('Clear list reducer:', function () {
  beforeAll(function () {
    var _resources = (0, _index.resources)({
      name: RESOURCE_NAME
    }, {
      clearList: true
    }),
        reducers = _resources.reducers,
        clearUsers = _resources.actionCreators.clearList;

    this.clearUsers = clearUsers;
    this.reducers = reducers;
    this.initialState = _objectSpread(_objectSpread({}, _index.RESOURCES), {}, {
      items: {
        1: {
          values: {
            id: 1,
            username: 'Jill'
          },
          status: {
            type: _Statuses.SUCCESS,
            syncedAt: 2,
            requestedAt: 1
          }
        }
      },
      lists: _defineProperty({}, _EmptyKey["default"], {
        positions: [1],
        status: {
          type: _Statuses.SUCCESS
        }
      })
    });
  });
  describe('Given the user attempts to clear a resource list that isn\'t in the store', function () {
    beforeAll(function () {
      setupInitialState(this, RESOURCE_NAME, this.initialState, 100);
    });
    it('then DOES nothing', function () {
      expect((0, _resourceAssertions.resourcesDefinition)(this, RESOURCE_NAME)).toEqual(this.initialState);
    });
  });
  describe('Given the user attempts to clear a resource list in the store', function () {
    beforeAll(function () {
      setupInitialState(this, RESOURCE_NAME, this.initialState, _EmptyKey["default"]);
    });
    it('then clears the list', function () {
      expect((0, _resourceAssertions.resourcesDefinition)(this, RESOURCE_NAME).lists[_EmptyKey["default"]]).toEqual(undefined);
    });
  });

  function setupInitialState(context, resourcesName, initialState, listId) {
    context.store = (0, _buildStore3["default"])(_defineProperty({}, resourcesName, _objectSpread(_objectSpread({}, initialState), {}, {
      newItemKey: null
    })), _defineProperty({}, resourcesName, context.reducers));
    context.store.dispatch(context.clearUsers(listId));
  }
});