"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.enqueuePendingAction = enqueuePendingAction;
exports.registerActionEnd = registerActionEnd;
exports.isActionPending = isActionPending;
exports.clearPendingActions = clearPendingActions;

var _dig = _interopRequireDefault(require("./object/dig"));

var _undig = _interopRequireDefault(require("./object/undig"));

var _undigDelete = _interopRequireDefault(require("./object/undigDelete"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var actionsRegistry = {};

function enqueuePendingAction(actionType) {
  var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : actionType;
  (0, _undig["default"])(actionsRegistry, [actionType, key], true);
}

function registerActionEnd(actionType) {
  var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : actionType;
  (0, _undigDelete["default"])(actionsRegistry, [actionType, key]);
}

function isActionPending(actionType) {
  var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : actionType;
  return (0, _dig["default"])(actionsRegistry, [actionType, key]);
}

function clearPendingActions() {
  actionsRegistry = {};
}