"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registerRequestStart = registerRequestStart;
exports.registerRequestEnd = registerRequestEnd;
exports.isRequestInProgress = isRequestInProgress;
exports.clearRegisteredRequests = clearRegisteredRequests;

var _hasKey = _interopRequireDefault(require("./object/hasKey"));

var _isEmpty = _interopRequireDefault(require("./list/isEmpty"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var requestsMap = {};

function registerRequestStart(requestType, url) {
  if (!(0, _hasKey["default"])(requestsMap, url)) {
    requestsMap[url] = {};
  }

  if (!(0, _hasKey["default"])(requestsMap[url], requestType)) {
    requestsMap[url][requestType] = [];
  }

  requestsMap[url][requestType].push(Date.now);
}

function registerRequestEnd(requestType, url) {
  if ((0, _hasKey["default"])(requestsMap, url)) {
    if ((0, _hasKey["default"])(requestsMap[url], requestType)) {
      requestsMap[url][requestType].shift();

      if ((0, _isEmpty["default"])(requestsMap[url][requestType])) {
        Reflect.deleteProperty(requestsMap[url], requestType);
      }
    }

    if ((0, _isEmpty["default"])(requestsMap[url])) {
      Reflect.deleteProperty(requestsMap, url);
    }
  }
}

function isRequestInProgress(requestType, url) {
  return (0, _hasKey["default"])(requestsMap, url) && (0, _hasKey["default"])(requestsMap[url], requestType);
}

function clearRegisteredRequests() {
  requestsMap = {};
}