"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _adaptOptionsForSingularResource = _interopRequireDefault(require("../action-creators/helpers/adaptOptionsForSingularResource"));

var _DataStructures = require("../constants/DataStructures");

var _Statuses = require("../constants/Statuses");

var _ActionQueue = require("./ActionQueue");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function getOrInitializeNewItem(options, resourcesState, paramsOrValues, valuesOrActionCreatorOptions, optionalActionCreatorOptions) {
  var _adaptOptionsForSingu = (0, _adaptOptionsForSingularResource["default"])({
    paramsOptional: true,
    acceptsValues: true
  }, [paramsOrValues, valuesOrActionCreatorOptions, optionalActionCreatorOptions]),
      values = _adaptOptionsForSingu.values;

  var key = resourcesState.newItemKey;
  var existingItem = resourcesState.items[key];

  if (existingItem) {
    return existingItem;
  }

  var _newItem = _objectSpread(_objectSpread({}, _DataStructures.ITEM), {}, {
    values: values,
    status: _objectSpread(_objectSpread({}, _DataStructures.ITEM.status), {}, {
      type: _Statuses.NEW
    })
  });

  if (!(0, _ActionQueue.isActionPending)(options.action)) {
    (0, _ActionQueue.enqueuePendingAction)(options.action);
    setTimeout(function () {
      options.newItem(values);
      (0, _ActionQueue.registerActionEnd)(options.action);
    }, 0);
  }

  return _newItem;
}

var _default = getOrInitializeNewItem;
exports["default"] = _default;