"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _isObject = _interopRequireDefault(require("../object/isObject"));

var _dictionaryFrom = _interopRequireDefault(require("../object/dictionaryFrom"));

var _arrayFrom = _interopRequireDefault(require("../array/arrayFrom"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function pluck(target, whitelist) {
  var _whitelist = (0, _arrayFrom["default"])(whitelist);

  if ((0, _isObject["default"])(target)) {
    var subset = {};

    _whitelist.forEach(function (attribute) {
      subset[attribute] = target[attribute];
    });

    return subset;
  } else if (Array.isArray(target)) {
    var whitelistDict = (0, _dictionaryFrom["default"])(_whitelist);
    return target.reduce(function (memo, item) {
      if (whitelistDict[item]) {
        memo.push(item);
      }

      return memo;
    }, []);
  } else {
    return target;
  }
}

var _default = pluck;
exports["default"] = _default;