"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _adaptOptionsForSingularResource = _interopRequireDefault(require("../action-creators/helpers/adaptOptionsForSingularResource"));

var _getItem = _interopRequireDefault(require("./getItem"));

var _wrapInObject = _interopRequireDefault(require("./object/wrapInObject"));

var _getItemKey = _interopRequireDefault(require("../action-creators/helpers/getItemKey"));

var _index = require("../public-helpers/index");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function saveItem(options, resourcesState, paramsOrValues, valuesOrActionCreatorOptions, optionalActionCreatorOptions) {
  var keyBy = options.keyBy,
      singular = options.singular;

  var _adaptOptionsForSingu = (0, _adaptOptionsForSingularResource["default"])({
    paramsOptional: false,
    acceptsValues: true
  }, [paramsOrValues, valuesOrActionCreatorOptions, optionalActionCreatorOptions]),
      values = _adaptOptionsForSingu.values,
      params = _adaptOptionsForSingu.params,
      actionCreatorOptions = _adaptOptionsForSingu.actionCreatorOptions;

  var normalizedParams = (0, _wrapInObject["default"])(params, keyBy);
  var key = (0, _getItemKey["default"])(normalizedParams, {
    keyBy: keyBy,
    singular: singular
  });
  var existingItem = (0, _getItem["default"])(resourcesState, key);

  if ((0, _index.isCreated)(existingItem)) {
    return options.updateItem(params, values, actionCreatorOptions);
  }

  return options.createItem(params, values, actionCreatorOptions);
}

var _default = saveItem;
exports["default"] = _default;